---
title: Media Session action types
slug: Web/API/MediaSessionAction
tags:
  - API
  - Action Type
  - Enum
  - Enumerated Type
  - Media Session API
  - Media Sessionn Action Type
  - MediaSession API
  - MediaSessionAction
  - Reference
  - Type
---
<p>To support an action on a media session, such as seeking, pausing, or changing tracks, you need to call the {{domxref("MediaSession")}} interface's {{domxref("MediaSession.setActionHandler", "setActionHandler()")}} method to establish a handler for that action. <span class="seoSummary">The specific type of media session action to be handled on a <code>MediaSession</code> is identified using a string from the <code>MediaSessionAction</code> enumerated type.</span></p>

<h2 id="Syntax">Syntax</h2>

<p>A media session action's type is specified using a string from the <code>MediaSessionAction</code> enumerated type.</p>

<h3 id="Values">Values</h3>

<p>Each of the actions is a common media session control request. Implement support for each of these in order to allow that type of action to be performed. The following strings identify the currently available types of media session action:</p>

<div id="action-types">
<dl>
 <dt><a id="nexttrack"><code>nexttrack</code></a></dt>
 <dd>Advances playback to the next track.</dd>
 <dt><a id="pause"><code>pause</code></a></dt>
 <dd>Pauses playback of the media.</dd>
 <dt><a id="play"><code>play</code></a></dt>
 <dd>Begins (or resumes) playback of the media.</dd>
 <dt><a id="previoustrack"><code>previoustrack</code></a></dt>
 <dd>Moves back to the previous track.</dd>
 <dt><a id="seekbackward"><code>seekbackward</code></a></dt>
 <dd>Seeks backward through the media from the current position. The {{domxref("MediaSessionActionDetails")}} property {{domxref("MediaSessionActionDetails.seekOffset", "seekOffset")}} specifies the amount of time to seek backward.</dd>
 <dt><a id="seekforward"><code>seekforward</code></a></dt>
 <dd>Seeks forward from the current position through the media. The {{domxref("MediaSessionActionDetails")}} property {{domxref("MediaSessionActionDetails.seekOffset", "seekOffset")}} specifies the amount of time to seek forward.</dd>
 <dt><a id="seekto"><code>seekto</code></a></dt>
 <dd>Moves the playback position to the specified time within the media. The time to which to seek is specified in the {{domxref("MediaSessionActionDetails")}} property {{domxref("MediaSessionActionDetails.seekTime", "seekTime")}}. If you intend to perform multiple <code>seekto</code> operations in rapid succession, you can also specify the {{domxref("MediaSessionActionDetails")}} property {{domxref("MediaSessionActionDetails.fastSeek", "fastSeek")}} property with a value of <code>true</code>. This lets the browser know it can take steps to optimize repeated operations, and is likely to result in improved performance.</dd>
 <dt><a id="skipad"><code>skipad</code></a></dt>
 <dd>Skips past the currently playing advertisement or commercial. This action may or may not be available, depending on the platform and {{Glossary("user agent")}}, or may be disabled due to subscription level or other circumstances.</dd>
 <dt><a id="stop"><code>stop</code></a></dt>
 <dd>Halts playback entirely.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>A media session action may be generated by any media session action source; these sources include anything from UI widgets within the browser itself to media control keys on the user's keyboard to buttons on the user's headset or earbuds.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Adding_action_handlers">Adding action handlers</h3>

<p>This example implements seek forward and backward actions for an audio player by setting up the <code>{{anch("seekforward")}}</code> and <code>{{anch("seekbackward")}}</code> action handlers.</p>

<pre class="brush: js notranslate">let skipTime = 10; // Time to skip in seconds

navigator.mediaSession.setActionHandler('seekforward', details =&gt; {
 // User clicked "Seek Forward" media notification icon.
 audio.currentTime = Math.min(audio.currentTime + skipTime,
               audio.duration);
});

navigator.mediaSession.setActionHandler('seekbackward', details =&gt; {
 // User clicked "Seek Backward" media notification icon.
 audio.currentTime = Math.max(audio.currentTime - skipTime, 0);
});
</pre>

<p>In this case, both the <code>seekforward</code> and <code>seekbackward</code> handlers are using a fixed distance, ignoring the time specified by the {{domxref("MediaSessionActionDetails")}} passed into the handler.</p>

<h3 id="Supporting_multiple_actions_in_one_handler_function">Supporting multiple actions in one handler function</h3>

<p>You can also, if you prefer, use a single function to handle multiple action types, by checking the value of the <code>MediaSessionActionDetails</code> object's {{domxref("MediaSessionActionDetails.action", "action")}} property:</p>

<pre class="brush: js notranslate">let skipTime = 7;

navigator.mediaSession.setActionHandler("seekforward", handleSeek);
navigator.mediaSession.setActionHandler("seekbackward", handleSeek);

function handleSeek(details) {
  switch(details.action) {
    case "seekforward":
      audio.currentTime = Math.min(audio.currentTime + skipTime,
              audio.duration);
      break;
    case "seekbackward":
      audio.currentTime = Math.max(audio.currentTime - skipTime, 0);
      break;
  }
}
</pre>

<p>Here, the <code>handleSeek()</code> function handles both <code>seekbackward</code> and <code>seekforward</code> actions.</p>

<h3 id="Using_data_provided_by_MediaSessionActionDetails">Using data provided by MediaSessionActionDetails</h3>

<p>In this example, instead of seeking a specified distance, the <code>seekforward</code> and <code>seekbackward</code> handlers use the time specified in the <code>MediaSessionActionDetails</code> object's {{domxref("MediaSessionActionDetails.seekOffset", "seekOffset")}} property.</p>

<pre class="brush: js notranslate">navigator.mediaSession.setActionHandler("seekforward", handleSeek);
navigator.mediaSession.setActionHandler("seekbackward", handleSeek);

function handleSeek(details) {
  switch(details.action) {
    case "seekforward":
      audio.currentTime = Math.min(audio.currentTime + details.seekOffset,
                                   audio.duration);
      break;
    case "seekbackward":
      audio.currentTime = Math.max(audio.currentTime - details.seekOffset, 0);
      break;
  }
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Session','#enumdef-mediasessionaction','Media Session action types')}}</td>
   <td>{{Spec2('Media Session')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaSessionAction")}}</p>
</div>
</div>
